create table cd (
    id         number(5),
    interpret  varchar2(35),
    titul      varchar2(50),
    stopa      number(2),
    pisen      varchar2(50),
    d_min      number(2),
    d_sec      number(2),
    poznamka   varchar2(80)
);

create table tituly (
    id         number(5)    primary key,
    titul      varchar2(50) not null,
    interpret  varchar2(35) not null
);

create table pisne (
    id        number(5) not null,
    stopa     number(2),
    pisen     varchar2(50),
    d_min     number(2),
    d_sec     number(2),
    poznamka  varchar2(80),
    constraint fk_pisne foreign key (id)
        references tituly (id)
);

insert into tituly (id, titul, interpret)
    values (1, 'Symphony no. 9 in E minor - From the New World', 'Antonin Dvorak');
insert into tituly (id, titul, interpret)
    values (2, 'One Hot Minute', 'The Red Hot Chili Peppers');
insert into tituly (id, titul, interpret)
    values (3, 'Abbey Road', 'The Beatles');
insert into tituly (id, titul, interpret)
    values (4, 'No Need To Argue', 'The Cranberies');
insert into tituly (id, titul, interpret)
    values (5, 'The Joshua Tree', 'U2');
insert into tituly (id, titul, interpret)
    values (6, 'Eine kleine Nachtmusik', 'Wolfgang Amadeus Mozart');
 
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (1, 1, 'Adagio - Allegro molto', 9, 58, 'Prvni pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (1, 2, 'Largo', 12, 27 ,'Druha pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (1, 3, 'Molto Vivace', 8, 36, 'Treti pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (1, 4, 'Allegro con fuoco', 11, 25, 'Ctvrta pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 1, 'Warped', 5, 4, 'Prvni pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 2, 'Aeroplane', 4, 45, 'I like pleasure spiked with drain...');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 3, 'Deep Kick', 6, 34, 'Treti pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 4, 'My Friends', 4, 3, 'Ctvrta pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 5, 'Coffee Shop', 3, 9, 'Pata pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 6, 'Pea', 1, 47, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 7, 'One Big Mob', 6, 2, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 8, 'Walkabout', 5, 8, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 9, 'Tearjerker', 4, 19, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 10, 'One Hot Minute', 6, 42, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 11, 'Falling Into Grace', 3, 48, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 12, 'Shallow Thy Jane', 4, 34, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (2, 13, 'Transcending', 5, 47, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 1, 'Come Together',4, 21, 'Prvni pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 2, 'Something', 3, 3, 'Druha pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 3, 'Maxwell'||chr(39)||'s Silver Hammer', 3, 27, 'Treti pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 4, 'Oh! Darling', 3, 29, 'Ctvrta pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 5, 'Octopus'||chr(39)||'s Garden', 2, 52, 'Pata pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 6, 'I Want You (She'||chr(39)||'s So Heavy)', 7, 46, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 7, 'Here Comes The Sun', 3, 6, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 8, 'Because', 2, 45, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 9, 'You Never Give Me Your Money', 4, 2, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 10, 'Sun King', 2, 27, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 11, 'Mean Mr. Mustard', 1, 6, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 12, 'Polythene Pam', 1, 13, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 13, 'She Came In Through The Bathroom Window', 1, 58, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 14, 'Golden Slumbers', 1, 31, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 15, 'Carry That Weight', 1, 37, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 16, 'The End', 2, 20, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (3, 17, 'Her Majesty', 0, 21, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 1, 'Ode To My Family', 4, 32, 'Prvni pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 2, 'I Can'||chr(39)||'t Be With You', 3, 9, 'Druha pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 3, 'Twenty One', 3, 6, 'Treti pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 4, 'Zombie', 5, 7, 'Ctvrta pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 5, 'Empty', 3, 26, 'Pata pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 6, 'Everything I Said',3, 53, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 7, 'The Icicle Melts', 2, 54, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 8, 'Disappointment', 4, 14, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 9, 'Ridiculous Thoughts', 4, 32, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 10, 'Dreaming My Dreams', 3, 37, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 11, 'Yeat'||chr(39)||'s Grave', 2, 59, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 12, 'Daffodil Lament', 6, 14, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (4, 13, 'No Need To Argue', 2, 54, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 1, 'Where The Streets Have No Name', 5, 35, 'Prvni pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 2, 'I Still Haven'||chr(39)||'t Found What I'||chr(39)||'m Looking For', 4, 38, 'Druha pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 3, 'With Or Without You', 4, 57, 'Treti pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 4, 'Bullet The Blue Sky', 4, 32, 'Ctvrta pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 5, 'Running To Stand Still', 4, 20, 'Pata pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 6, 'Red Hill Mining Town', 4, 51, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 7, 'In God'||chr(39)||'s Country', 3, 37, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 8, 'Trip Through Your Wires', 3, 32, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 9, 'One Tree Hill', 5, 24, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 10, 'Exit', 4, 14, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (5, 11, 'Mothers Of The Disappeared', 5, 14, null);
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (6, 1, 'Allegro', 5, 37, 'Prvni pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (6, 2, 'Romaze : Andante', 6, 43, 'Druha pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (6, 3, 'Menuetto : Allegretto', 2, 8, 'Treti pisnicka');
insert into pisne (id, stopa, pisen, d_min, d_sec, poznamka)
    values (6, 4, 'Rondo : Allegro', 3, 18, 'Ctvrta pisnicka');

insert into cd
  select  t.id, t.interpret, t.titul,
          p.stopa, p.pisen, p.d_min, p.d_sec, p.poznamka
    from  tituly t, pisne p
   where  t.id = p.id;

commit;

create table predmety (
    id              number(5) primary key,
    zkratka         varchar2(10) not null,
    katedra         varchar2(3)  not null,
    nazev           varchar2(30) not null,
    garant          varchar2(20),
    kredity         number(2),
    pocet_studentu  number(3),
    constraint pk_predmety unique (zkratka, katedra)
);

create table mistnosti (
    id       number(5) primary key,
    zkratka  varchar2(10) not null,
    kapacita number(5)
);

create table rozvrh (
    id_predm    number(5),
    id_mistn    number(5),
    semestr     varchar2(2) not null,
    den         varchar2(2),
    h_od        number(2),
    h_do        number(2),
    poznamka    varchar2(40),
    constraint fk_predm foreign key (id_predm)
        references predmety(id),
    constraint fk_mistn foreign key (id_mistn)
        references mistnosti(id)
);

insert into predmety (id, zkratka, katedra, nazev, garant, kredity, pocet_studentu)
    values (1, 'PC', 'KIV', 'Programovani v C', 'P. Herout', 5, 80);
insert into predmety (id, zkratka, katedra, nazev, garant, kredity, pocet_studentu)
    values (2, 'KP', 'KIV', 'Konstrukce pocitacu', 'tajemnik', 5, null);
insert into predmety (id, zkratka, katedra, nazev, garant, kredity, pocet_studentu)
    values (3, 'PL', 'KTS', 'Plavani', 'A. Dura', 2, 10);
insert into predmety (id, zkratka, katedra, nazev, garant, kredity, pocet_studentu)
    values (4, 'HB', 'KHK', 'Hra na banjo', 'I. Mladek', 2, null);
insert into predmety (id, zkratka, katedra, nazev, garant, kredity, pocet_studentu)
    values (5, 'PD', 'KIV', 'Prenos dat', 'Max', 5, 20);

insert into mistnosti (id, zkratka, kapacita)
    values (1, 'UD101', null);
insert into mistnosti (id, zkratka, kapacita)
    values (2, 'UL409', 20);
insert into mistnosti (id, zkratka, kapacita)
    values (3, 'UL404', 10);
insert into mistnosti (id, zkratka, kapacita)
    values (4, 'UP104', 100);

insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (1, 4, 'LS', 'PO', 5, 7, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (1, 2, 'LS', 'ST', 4, 5, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (1, 2, 'LS', 'ST', 6, 7, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (1, 2, 'LS', 'ST', 8, 9, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (2, 3, 'ZS', 'CT', 2, 3, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (2, 3, 'ZS', 'CT', 4, 5, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (4, 1, 'LS', 'PA', 10, 12, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (5, 2, 'ZS', 'CT', 1, 3, null);
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (null, 4, 'LS', 'PA', 8, 9, 'Seminar WEBnet');
insert into rozvrh (id_predm, id_mistn, semestr, den, h_od, h_do, poznamka)
    values (null, 4, 'ZS', 'PA', 10, 11, 'Zasedani senatu');

commit;

create table karty (
    id_karty     number(5) primary key,
    pin          number(5) not null unique,
    stav         number(1),
    platnost_od  date,
    platnost_do  date
);

create table osoby (
    id_osoby  number(5) primary key,
    id_nad    number(5),
    prijmeni  varchar2(25) not null,
    jmeno     varchar2(25) not null,
    id_karty  number(5),
    constraint fk_osoby_karty foreign key (id_karty)
        references karty (id_karty)
);

alter table osoby
    add constraint fk_osoby_osoby foreign key (id_nad)
           references osoby (id_osoby);

create table skupiny (
    id_skupiny  number(5) primary key,
    jmeno       varchar(25) not null unique
);

create table clenove_skupin (
    id_skupiny  number(5) not null,
    id_osoby    number(5) not null,
    constraint fk_clenove_skup foreign key (id_skupiny)
        references skupiny (id_skupiny),
    constraint fk_clenove_osob foreign key (id_osoby)
        references osoby (id_osoby)
);

create table objekty (
    id_objektu  number(5) primary key,
    jmeno       varchar2(25) not null unique,
    adresa      varchar(25)
);

create table zony (
    id_zony  number(5) primary key,
    jmeno    varchar2(25) not null unique
);

create table pristupy_osob (
    id_osoby    number(5) not null,
    id_objektu  number(5) not null,
    id_zony     number(5) not null,
    constraint fk_po_osob foreign key (id_osoby)
        references osoby (id_osoby),
    constraint fk_po_obj foreign key (id_objektu)
        references objekty (id_objektu),
    constraint fk_po_zony foreign key (id_zony)
        references zony (id_zony)
);

create table pristupy_skupin (
    id_skupiny  number(5) not null,
    id_objektu  number(5) not null,
    id_zony     number(5) not null,
    constraint fk_ps_skup foreign key (id_skupiny)
        references skupiny (id_skupiny),
    constraint fk_ps_obj foreign key (id_objektu)
        references objekty (id_objektu),
    constraint fk_ps_zony foreign key (id_zony)
        references zony (id_zony)
);

insert into karty (id_karty, pin)
    values (1, 1234);
insert into karty (id_karty, pin)
    values (2, 7583);
insert into karty (id_karty, pin)
    values (3, 9602);
insert into karty (id_karty, pin)
    values (4, 3018);
insert into karty (id_karty, pin)
    values (5, 8349);
insert into karty (id_karty, pin)
    values (6, 4477);
insert into karty (id_karty, pin)
    values (7, 2003);
insert into karty (id_karty, pin)
    values (8, 5327);

insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(1, null, 'Vlastimil', 'Dudacek', 1);
insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(2, 1, 'Karel', 'Vavricka', 4);
insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(3, 1, 'Stanislav', 'Herout', 5);
insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(4, 2, 'Maxmilian', 'Rohlik', 6);
insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(5, 2, 'Ondrej', 'Pesicka', 7);
insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(6, 2, 'Pavel', 'Bokr', 8);
insert into osoby (id_osoby, id_nad, jmeno, prijmeni, id_karty)
    values(7, 3, 'Antonin', 'Dura', NULL);

insert into skupiny values (1, 'Vsichni');
insert into skupiny values (2, 'Udrzbari');
insert into skupiny values (3, 'Administrativa');
insert into skupiny values (4, 'Vedeni');

insert into clenove_skupin values (1, 1);
insert into clenove_skupin values (1, 2);
insert into clenove_skupin values (1, 3);
insert into clenove_skupin values (1, 4);
insert into clenove_skupin values (1, 5);
insert into clenove_skupin values (1, 6);
insert into clenove_skupin values (2, 1);
insert into clenove_skupin values (2, 2);
insert into clenove_skupin values (3, 4);
insert into clenove_skupin values (3, 5);
insert into clenove_skupin values (3, 6);
insert into clenove_skupin values (4, 3);

insert into objekty (id_objektu, jmeno, adresa)
    values(1, 'Knihovna', 'Univerzitni 22');
insert into objekty (id_objektu, jmeno, adresa)
    values(2, 'Servrovna', 'Univerzitni 22');
insert into objekty (id_objektu, jmeno, adresa)
    values(3, 'Sekretariat', 'Univerzitni 22');

insert into zony values (1, 'Neomezena');
insert into zony values (2, 'Provoz 7:00 - 22:00');
insert into zony values (3, 'Nocni 22:00 - 0:00');

insert into pristupy_osob values (5, 2, 3);
insert into pristupy_osob values (3, 3, 3);

insert into pristupy_skupin values (1, 1, 2);
insert into pristupy_skupin values (2, 2, 1);
insert into pristupy_skupin values (3, 3, 2);
insert into pristupy_skupin values (4, 3, 1);

commit;
